# Netint Transcoder Release Package
This release package contains Firmware, Software, Documents, and supporting files for the Netint
T408/T432 video transcoder.

## Components
| File                                             | Description                      |
| ------------------------------------------------ | -------------------------------- |
| Codensity_T4XX_Software_Release_V\*.\*.\*.tar.gz | SW release tarball               |
| HEIF_Converter_Demo_Guide_T408_V\*.\*.\*.pdf     | HEIF converter documentation     |
| heif_converter_V\*.\*.\*.tar.gz                  | HEIF converter tarball           |
| IntegrationProgrammingGuideT408_T432_FW\*_\*.pdf | Netint FW/SW primary usage guide |
| QuickStartGuideT408_T432_FW\*_\*.pdf             | Netint FW/SW installation guide  |
| T4XX_FW_V\*.\*.\*_release_notes.txt              | FW release notes                 |
| t4xx_quick_installer.sh                          | FW/SW guided installation script |
| T4XX_SW_V\*.\*.\*_release_notes.txt              | SW release notes                 |
| T4XX_V\*.\*.\*.tar.gz                            | FW release tarball               |
| README.md                                        | This file                        |
| clamscan.log                                     | Clam AV scan log                 |
| sentinelscan.log                                 | SentinelOne AV scan log          |

## Installation
For typical linux environments the `t4xx_quick_installer.sh` can be used.  
Alternatively, refer to `QuickStartGuideT408_V*.pdf` for manual installation instructions.

If installing to a special environment (eg. Windows, Android, etc.) consult engineering support.

## Further Information
For detailed information on individual components, check the `README` files within the tarball.
Scripts typically have help text which can be accessed with the `-h` param.

Special topics, such as direct libxcoder API integration or HDR usage, has supporting 
documentation describing their use. Please inquire with a Netint engineering support contact for 
the topic's application notes.
