/* Copyright (c) 2015-2017, Nokia Technologies Ltd.
 * All rights reserved.
 *
 * Licensed under the Nokia High-Efficiency Image File Format (HEIF) License (the "License").
 *
 * You may not use the High-Efficiency Image File Format except in compliance with the License.
 * The License accompanies the software and can be found in the file "LICENSE.TXT".
 *
 * You may also obtain the License at:
 * https://nokiatech.github.io/heif/license.txt
 */

#include "imagemasterwriter.hpp"
#include "services.hpp"
#include "writerconstants.hpp"

#define ANDROID_TO_STRING_HACK
#include "androidhacks.hpp"

ImageMasterWriter::ImageMasterWriter(const IsoMediaFile::Master& config, const std::vector<std::string>& handlerType,
    const std::uint32_t contextId,DataServe *pDS,NIIdSpace *pID) :
    RootMetaImageWriter(handlerType, contextId,pDS,pID),
    mConfig(config)
{
}

void ImageMasterWriter::write(MetaBox* metaBox)
{
    RootMetaImageWriter::initWrite();
    storeValue("uniq_bsid", std::to_string(mConfig.uniq_bsid));
    storeValue("capsulation", META_ENCAPSULATION);
    storeValue("bitstream", mConfig.file_path);
    RootMetaImageWriter::parseInputBitStream(mConfig.file_path, mConfig.code_type);
    MetaWriter::hdlrWrite(metaBox);
    RootMetaImageWriter::ilocWrite(metaBox);
    RootMetaImageWriter::iinfWrite(metaBox, mConfig.hidden);
    RootMetaImageWriter::iprpWrite(metaBox);
}

void ImageMasterWriter::app_write(MetaBox* metaBox, uint8_t *compressed, int size)
{
    RootMetaImageWriter::initWrite();
    storeValue("uniq_bsid", std::to_string(mConfig.uniq_bsid));
    storeValue("capsulation", META_ENCAPSULATION);
    storeValue("bitstream", mConfig.file_path);
    RootMetaImageWriter::app_parseInputBitStream(mConfig.file_path, mConfig.code_type, compressed, size);
    MetaWriter::hdlrWrite(metaBox);
    RootMetaImageWriter::ilocWrite(metaBox);
    RootMetaImageWriter::iinfWrite(metaBox, mConfig.hidden);
    RootMetaImageWriter::iprpWrite(metaBox);
}
