#ifndef _NETINT_API_ENCODER_HPP_
#define _NETINT_API_ENCODER_HPP_
#include "ICodec.hpp"
#include <list>
#include <vector>
#include "writercfg.hpp"
#include "writerapp.hpp"
struct Packet_info : public ni_packet_t
{
	Packet_info()
	{};
	Packet_info(ni_packet_t&packet)
	{
		this->data_len = packet.data_len;
		this->dts = packet.dts;
		this->end_of_stream = packet.end_of_stream;
		this->frame_type = packet.frame_type;
		this->pos = packet.pos;
		this->pts = packet.pts;
		this->video_height = packet.video_height;
		this->video_width = packet.video_width;
	};
	Packet_info operator  &= (ni_packet_t&packet)
	{
		this->data_len = packet.data_len;
		this->dts = packet.dts;
		this->end_of_stream = packet.end_of_stream;
		this->frame_type = packet.frame_type;
		this->pos = packet.pos;
		this->pts = packet.pts;
		this->video_height = packet.video_height;
		this->video_width = packet.video_width;
		return *this;
	}
	Packet_info operator  &= (Packet_info &packet)
	{
		this->data_len = packet.data_len;
		this->dts = packet.dts;
		this->end_of_stream = packet.end_of_stream;
		this->frame_type = packet.frame_type;
		this->pos = packet.pos;
		this->pts = packet.pts;
		this->video_height = packet.video_height;
		this->video_width = packet.video_width;
		return *this;
	}
};

class Encoder :public ICodec
{
public :
	Encoder();
	virtual ~Encoder();
	/******
	* Init codec resource.
	*/

	/******
	* Set Input, output and basic parameter.
	*/
	int init(ni_codec_format_t codec,
			const char * destFile,
			int width,
			int height,
			int fps,
			int bitrate);
	void setParam(const char * key,const char * value);
	int sendData();
	int allocateBuffer(unsigned char ** buffer,unsigned int len,unsigned int extraSize=0);
	int receiveData();
	int resetSession();
	int init_encode_default_param(int width,
			int height,
			int fps,
			int bitrate);
	void addHEIFFile(const char *output)
	{
		m_heif_list.push_back(output);
	}

protected:
  unsigned long m_loadpixel=0;
  int m_frameSize=0;
  int m_height_aligned=0;
  int m_width_aligned = 0;
  int m_height_aligned_array[4]={0};
  int m_dst_stride[4]={0};
  bool m_firstRecv=true;
  int m_data_len = 512*1024;
  uint8_t * m_data = new uint8_t[m_data_len] ;

  int m_header_len =0;
  int m_repeated_header=0;
  std::list<string> m_heif_list;
  WriterApp m_heif_writer;


friend class YuvToHeic;

};

#endif
