/*
 * ICodec.hpp
 *
 *  Created on: 2019-10-04
 *      Author: Ray
 */

#ifndef _NETINT_API_ICODEC_HPP_
#define _NETINT_API_ICODEC_HPP_
#include<pthread.h>
#include <ni_device_api.h>
#include <map>
#include "FileSource.hpp"
using namespace std;
enum CODEC_TYPE
{
	ENCODER=0,
	DECODER,
	TRANSCODER
};
class ICodec
{
public:
	ICodec(CODEC_TYPE codec);
	virtual ~ICodec();
	virtual int init(ni_codec_format_t codec,
			const char * destFile,
			int width,
			int height,
			int fps,
			int bitrate) ;
	virtual int assignDevice(int hw_id);
	virtual int removeDevice();
	virtual int openSession();
	virtual void setParam(const char * key,const char * value){};
	virtual int closeSession();
	virtual int allocateBuffer(unsigned char** buffer,unsigned int len, unsigned int extraSize=0){return 0;};
	virtual int sendData()=0;
	virtual int receiveData()=0;
	static void* receiveProc(void *pCodec);
	int startRecv(bool bindCore=false,int core = 0);
	int stopRecv(bool wait=true);
	static int OpenDevice(const char * device_name,const char* device_blk_name);
	static int CloseDevice(const char * device_name,const char* device_blk_name);
protected:
	int m_width;
	int m_height;
	int m_fps;
	int m_bitrate;
	int m_qp = 32;
  bool m_firstFrame;
	CODEC_TYPE m_codec;
	FileSource m_dest;

	unsigned int m_maxIOSize=0;
	int m_device_handle;
  int m_eos_sent;
  int m_eos_received;
  bool m_resendFlag;
  //bool m_reRecvFlag;
  int m_receivedCnt;
  int m_sentCnt;
  bool m_recvActive;
  pthread_t m_recvThread;
	ni_codec_format_t m_encoderFormat ;
	ni_encoder_params_t  m_api_param;
	ni_session_context_t * m_session_ctx;
  ni_session_data_io_t m_in_frame;
  ni_session_data_io_t m_out_packet;
  static std::map<string,int> m_deviceHandles;
  static std::map<string,int> m_deviceIOSizes;
};

#endif /* ICODEC_HPP_ */
