#!/usr/bin/python3
import os
from tkinter import *
from tkinter import filedialog
from tkinter import ttk


class FolderSelect(Frame):
    def __init__(self, parent=None, folderDescription="", **kw):
        Frame.__init__(self, master=parent, **kw)
        self.folderPath = StringVar()
        self.lblName = Label(self, text=folderDescription)
        self.lblName.grid(row=0, column=0)
        self.entPath = Entry(self, textvariable=self.folderPath)
        self.entPath.grid(row=0, column=1)
        self.btnFind = ttk.Button(self, text="Browse Folder", command=self.setFolderPath)
        self.btnFind.grid(row=0, column=2)

    def setFolderPath(self):
        folder_selected = filedialog.askdirectory()
        self.folderPath.set(folder_selected)

    @property
    def folder_path(self):
        return self.folderPath.get()


def executeCommande():
    pathin_info = directory1Select.folder_path
    pathout_info = directory2Select.folder_path
    qp_info = qp.get()
    qp_spin_info = qp_spin.get()

    cmd = 'sudo ./NETINT_HEIC_convertor ' + pathin_info + ' ' + pathout_info + ' ' + str(qp_spin_info)
    print(cmd)
    os.system(cmd)


screen = Tk()
screen.geometry("400x300")
screen.title("NETINT.Inc")
heading = Label(text="HEIC Converter", bg="grey", fg="black", width="500", height="2")

folderPath = StringVar()
directory1Select = FolderSelect(screen, "Select Input Folder")
qp_text = Label(text="qp", )
qp_text_exp = Label(text="*qp values (18,22,25,28,32). Lower qp leads to better picture", )

qp_spin = IntVar()

directory1Select.grid(ipadx=0, ipady=20, columnspan=100)
directory2Select = FolderSelect(screen, "Select output Folder")
directory2Select.grid(ipadx=0, ipady=20)
qp_text.place(x=10, y=130)
qp = StringVar()

qp_spin = Spinbox(screen, from_=1, to=51, width=5)
qp_spin.place(x=30, y=130)

c = ttk.Button(screen, text="Convert", command=executeCommande)
c.place(x=150, y=220)
qp_text_exp.place(x=10, y=160)

screen.mainloop()
